/*=================================================================
* PDC_GetCihxDataTypes.cpp
*=================================================================*/

#include	"mex.h"
#include	<windows.h>
#include    <string.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{    
    PDC_ARCHIVE_HANDLE pHandle;
    unsigned long* pRet;    
    unsigned long* pErrorCode;
    char* pPath;
    PDC_ARCHIVE_DATA_HEAD pDataTypes[256];
    const char* fieldnames[]={"type","offset", "size"};
	unsigned long* pCount;
    mxArray* tmp;
    unsigned long buflen;
    
    plhs[ 0 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 2 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 3 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
      
    buflen = 256;
    pPath  = ( char * )malloc( sizeof( char )*buflen );  
	mxGetString( prhs[ 0 ],  pPath, buflen );
    
    pRet        = ( unsigned long * )mxGetPr( plhs[ 0 ] ); 
    pCount      = ( unsigned long * )mxGetPr( plhs[ 2 ] );
    pErrorCode	= ( unsigned long * )mxGetPr( plhs[ 3 ] );
     
    *pRet		= PDC_GetCihxDataTypes( pPath,  pDataTypes, pCount, pErrorCode );
    
    plhs[ 1 ]   = mxCreateStructMatrix( *pCount, 1, 3, fieldnames );
     
     for (int i = 0; i < *pCount; ++i) 
     {               
          tmp = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
          *( unsigned long * )mxGetPr( tmp ) = pDataTypes[i].type;
          mxSetFieldByNumber( plhs[ 1 ], i, 0, tmp );
           
          tmp = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
          *( unsigned long * )mxGetPr( tmp ) = pDataTypes[i].offset;
          mxSetFieldByNumber( plhs[ 1 ], i, 1, tmp );
           
          tmp = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
          *( unsigned long * )mxGetPr( tmp ) = pDataTypes[i].size;
          mxSetFieldByNumber( plhs[ 1 ], i, 2, tmp );
     }
}
