/*=================================================================
* PDC_OpenDevice2.c
*=================================================================*/
#include	"mex.h"
#include	<windows.h>
#include    <string.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
	PDC_DETECT_INFO nDetectInfo;
    unsigned long   *pRet;    
    unsigned long   *pDeviceNo;
    long            nMaxRetryCount;
    long            nConnectMode;
    unsigned long   *pErrorCode;
    
	plhs[ 0 ]						= mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 1 ]						= mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 2 ]						= mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    
	nDetectInfo.m_nDeviceCode       = ( unsigned long )mxGetScalar( mxGetFieldByNumber( prhs[ 0 ], 0, mxGetFieldNumber( prhs[ 0 ],"m_nDeviceCode" ) ) );
	nDetectInfo.m_nTmpDeviceNo      = ( unsigned long )mxGetScalar( mxGetFieldByNumber( prhs[ 0 ], 0, mxGetFieldNumber( prhs[ 0 ],"m_nTmpDeviceNo" ) ) );
	nDetectInfo.m_nInterfaceCode	= ( unsigned long )mxGetScalar( mxGetFieldByNumber( prhs[ 0 ], 0, mxGetFieldNumber( prhs[ 0 ],"m_nInterfaceCode" ) ) );
    nMaxRetryCount                  = ( long )mxGetScalar( prhs[ 1 ] );
    nConnectMode                    = ( long )mxGetScalar( prhs[ 2 ] );
   
   
    pRet							= ( unsigned long * )mxGetPr( plhs[ 0 ] ); 
    pDeviceNo						= ( unsigned long * )mxGetPr( plhs[ 1 ] );
    pErrorCode						= ( unsigned long * )mxGetPr( plhs[ 2 ] );
    
    *pRet							= PDC_OpenDevice2( &nDetectInfo, nMaxRetryCount, nConnectMode, pDeviceNo, pErrorCode );
}

