/*=================================================================
 * PDC_GetMemMCDLData.c
  *=================================================================*/
#include	"mex.h"
#include	<windows.h>
#include	<string.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
	
    unsigned long nDeviceNo;
    unsigned long nChildNo;
    long nFrameNo;
    unsigned long *pRet;
    PDC_MCDL_INFO nData;
    const char *fieldnames[] = { "m_nDigital","m_nAnalogA", "m_nAnalogB", "m_nAnalogC", "m_nAnalogD" };
    unsigned long *pErrorCode;    
    mxArray *data;
    int i;
    
   
    plhs[ 0 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 1 ]   = mxCreateStructMatrix( 1, 1, 5, fieldnames );
    plhs[ 2 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );

  
    nDeviceNo   = ( unsigned long )mxGetScalar( prhs[ 0 ] );
    nChildNo    = ( unsigned long )mxGetScalar( prhs[ 1 ] );
    nFrameNo    = ( long )mxGetScalar( prhs[ 2 ] );
    
 
    pRet        = ( unsigned long * )mxGetPr( plhs[ 0 ] );
    pErrorCode  = ( unsigned long * )mxGetPr( plhs[ 2 ] );
    
   
    *pRet       = PDC_GetMemMCDLData( nDeviceNo, nChildNo, nFrameNo, &nData, pErrorCode );
    
 
    data        = mxCreateNumericMatrix( 1, 10, mxUINT8_CLASS, mxREAL );
    for ( i = 0; i < 10; i++ )
    {    
        *( ( unsigned char * )mxGetPr( data ) + i )  = nData.m_nDigital[ i ];
    }    
    mxSetFieldByNumber( plhs[ 1 ], 0, 0, data ); 
    
    data        = mxCreateNumericMatrix( 1, 10, mxDOUBLE_CLASS, mxREAL );
    for ( i = 0; i < 10; i++ )
    {
        *( mxGetPr( data ) + i ) = nData.m_nAnalogA[ i ];
    }   
    mxSetFieldByNumber( plhs[ 1 ], 0, 1, data ); 
    
    data        = mxCreateNumericMatrix( 1, 10, mxDOUBLE_CLASS, mxREAL );
    for ( i = 0; i < 10; i++ )
    {
        *( mxGetPr( data ) + i ) = nData.m_nAnalogB[ i ];
    }    
    mxSetFieldByNumber( plhs[ 1 ], 0, 2, data );
    
    data        = mxCreateNumericMatrix( 1, 10, mxDOUBLE_CLASS, mxREAL );
    for ( i = 0; i < 10; i++ )
    {
        *( mxGetPr( data ) + i ) = nData.m_nAnalogC[ i ];
    }    
    mxSetFieldByNumber( plhs[ 1 ], 0, 3, data );
    
    data        = mxCreateNumericMatrix( 1, 10, mxDOUBLE_CLASS, mxREAL );
    for ( i = 0; i < 10; i++ )
    {
        *( mxGetPr( data ) + i ) = nData.m_nAnalogD[ i ];
    }
    mxSetFieldByNumber( plhs[ 1 ], 0, 4, data );    
}
