/*=================================================================
 * PDC_CreatePixelGainData.c
 *=================================================================*/
#include	"mex.h"
#include	<windows.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
    unsigned long nDeviceNo;
    unsigned long nChildNo;
    unsigned long nBitDepth;
    unsigned char *pSrc_8;
    unsigned short *pSrc_16;
	int	buflen;
    unsigned long *pRet;
    unsigned long *pErrorCode;
    
	plhs[ 0 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
	plhs[ 1 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );

	nDeviceNo   = ( unsigned long )mxGetScalar( prhs[ 0 ] );
	nChildNo    = ( unsigned long )mxGetScalar( prhs[ 1 ] );
	nBitDepth   = ( unsigned long )mxGetScalar( prhs[ 2 ] );
	buflen      = mxGetM( prhs[ 3 ] ) * mxGetN( prhs[ 3 ] ); 

    if ( nBitDepth == 8 )
    {
		pSrc_8		= ( unsigned char * )malloc( sizeof( unsigned char )*buflen );

		pSrc_8		= mxGetData( prhs[ 3 ] );

		pRet        = ( unsigned long * )mxGetPr( plhs[ 0 ] );
		pErrorCode  = ( unsigned long * )mxGetPr( plhs[ 1 ] );
    
		*pRet       = PDC_CreatePixelGainData( nDeviceNo, nChildNo, pSrc_8, pErrorCode );
    }   
    else if( nBitDepth > 8 )
    {
		pSrc_16		= ( unsigned short * )malloc( sizeof( unsigned short )*buflen );

		pSrc_16		= mxGetData( prhs[ 3 ] );

		pRet        = ( unsigned long * )mxGetPr( plhs[ 0 ] );
		pErrorCode  = ( unsigned long * )mxGetPr( plhs[ 1 ] );
		
		*pRet       = PDC_CreatePixelGainData( nDeviceNo, nChildNo, pSrc_16, pErrorCode );
    }
	else
	{
		*pRet       = 0;
		*pErrorCode = 5;
	}
}
