/*=================================================================
* PDC_GetAutoExposureRestriction.c
*=================================================================*/
#include	"mex.h"
#include	<windows.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
	
    unsigned long nDeviceNo;
    unsigned long nChildNo;
    unsigned long *pRet;
    unsigned long *pWidthStep;
    unsigned long *pHeightStep;
    unsigned long *pXPosStep;
    unsigned long *pYPosStep;
    unsigned long *pWidthMin;
    unsigned long *pHeightMin;
    unsigned long *pMaxValue;
    unsigned long *pMaxRange;
    unsigned long *pErrorCode;
    
    
    plhs[ 0 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 1 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 2 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 3 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 4 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 5 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 6 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 7 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 8 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 9 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    
	
	nDeviceNo    = ( unsigned long )mxGetScalar( prhs[ 0 ] );
    nChildNo     = ( unsigned long )mxGetScalar( prhs[ 1 ] );
    
   
    pRet        = ( unsigned long * )mxGetPr( plhs[ 0 ] );
    pWidthStep  = ( unsigned long * )mxGetPr( plhs[ 1 ] );
    pHeightStep = ( unsigned long * )mxGetPr( plhs[ 2 ] );
    pXPosStep   = ( unsigned long * )mxGetPr( plhs[ 3 ] );
    pYPosStep   = ( unsigned long * )mxGetPr( plhs[ 4 ] );
    pWidthMin   = ( unsigned long * )mxGetPr( plhs[ 5 ] );
    pHeightMin  = ( unsigned long * )mxGetPr( plhs[ 6 ] );
    pMaxValue   = ( unsigned long * )mxGetPr( plhs[ 7 ] );
    pMaxRange   = ( unsigned long * )mxGetPr( plhs[ 8 ] );
    pErrorCode  = ( unsigned long * )mxGetPr( plhs[ 9 ] );

   
	*pRet       = PDC_GetAutoExposureRestriction( nDeviceNo, nChildNo, pWidthStep, pHeightStep, pXPosStep, pYPosStep, pWidthMin, pHeightMin, pMaxValue, pMaxRange,  pErrorCode );
}