/*=================================================================
* PDC_GetColorEnhanceValue.c
*=================================================================*/
#include	"mex.h"
#include	<windows.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
    unsigned long nDeviceNo;
    unsigned long nChildNo;
    unsigned long nPlane;
    unsigned long *pRet;
    long *pR;
    long *pG;
    long *pB;
    unsigned long *pErrorCode;
    
    plhs[ 0 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 1 ]   = mxCreateNumericMatrix( 1, 1, mxINT32_CLASS, mxREAL );
    plhs[ 2 ]   = mxCreateNumericMatrix( 1, 1, mxINT32_CLASS, mxREAL );
    plhs[ 3 ]   = mxCreateNumericMatrix( 1, 1, mxINT32_CLASS, mxREAL );
    plhs[ 4 ]   = mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    
	nDeviceNo   = ( unsigned long )mxGetScalar( prhs[ 0 ] );
    nChildNo    = ( unsigned long )mxGetScalar( prhs[ 1 ] );
    nPlane      = ( unsigned long )mxGetScalar( prhs[ 2 ] );
    
    pRet        = ( unsigned long * )mxGetPr( plhs[ 0 ] );
    pR          = ( long * )mxGetPr( plhs[ 1 ] );
    pG          = ( long * )mxGetPr( plhs[ 2 ] );
    pB          = ( long * )mxGetPr( plhs[ 3 ] );
    pErrorCode  = ( unsigned long * )mxGetPr( plhs[ 4 ] );

	*pRet       = PDC_GetColorEnhanceValue( nDeviceNo, nChildNo, nPlane, pR, pG, pB, pErrorCode );
}

