/*====================================================================
* PDC_SetLUTUserParams.c
*====================================================================*/
#include	"mex.h"
#include	<windows.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
	
    unsigned long nDeviceNo;
    unsigned long nChildNo;
	unsigned long nLUTMode;
	PDC_LUT_PARAMS nParams;
    unsigned long *pRet;
    unsigned long *pErrorCode;
    const char *fieldnames[] = { "m_nBrightnessR","m_nBrightnessG", "m_nBrightnessB", "m_nContrastR", "m_nContrastG", "m_nContrastB", "m_nGainR", "m_nGainG", "m_nGainB", "m_nGammaR", "m_nGammaG", "m_nGammaB", "m_nPosiNegaR", "m_nPosiNegaG", "m_nPosiNegaB", "m_nFreeMode" };
    mxArray *params;

    
    plhs[ 0 ]				= mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 1 ]				= mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );

    
    nDeviceNo				= ( unsigned long )mxGetScalar( prhs[ 0 ] );
    nChildNo				= ( unsigned long )mxGetScalar( prhs[ 1 ] );
    nLUTMode				= ( unsigned long )mxGetScalar( prhs[ 2 ] );
	nParams.m_nBrightnessR	= ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nBrightnessR" ) ) );
	nParams.m_nBrightnessG	= ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nBrightnessG" ) ) );
	nParams.m_nBrightnessB	= ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nBrightnessB" ) ) );
	nParams.m_nContrastR	= ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nContrastR" ) ) );
	nParams.m_nContrastG	= ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nContrastG" ) ) );
	nParams.m_nContrastB	= ( long )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nContrastB" ) ) );
	nParams.m_nGainR		= mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nGainR" ) ) );
	nParams.m_nGainG		= mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nGainG" ) ) );
	nParams.m_nGainB		= mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nGainB" ) ) );
	nParams.m_nGammaR		= mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nGammaR" ) ) );
	nParams.m_nGammaG		= mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nGammaG" ) ) );
	nParams.m_nGammaB		= mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nGammaB" ) ) );
	nParams.m_nPosiNegaR	= ( unsigned char )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nPosiNegaR" ) ) );
	nParams.m_nPosiNegaG	= ( unsigned char )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nPosiNegaG" ) ) );
	nParams.m_nPosiNegaB	= ( unsigned char )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nPosiNegaB" ) ) );
	nParams.m_nFreeMode		= ( unsigned char )mxGetScalar( mxGetFieldByNumber( prhs[ 3 ], 0, mxGetFieldNumber( prhs[ 3 ],"m_nFreeMode" ) ) );


  
    pRet			= ( unsigned long * )mxGetPr( plhs[ 0 ] );
    pErrorCode		= ( unsigned long * )mxGetPr( plhs[ 1 ] );

	
	*pRet			= PDC_SetLUTUserParams( nDeviceNo, nChildNo, nLUTMode, &nParams, pErrorCode );
}

