/*=================================================================
* PDC_SetTransferOption.c
*=================================================================*/
#include	"mex.h"
#include	<windows.h>
#include	"PDCLIB.h"

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )
{
	
    unsigned long nDeviceNo;
    unsigned long nChildNo;
    unsigned long n8BitSel;
    unsigned long nBayer;
    unsigned long nInterleave;
    unsigned long *pRet;
    unsigned long *pErrorCode;

   
    plhs[ 0 ]		= mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );
    plhs[ 1 ]		= mxCreateNumericMatrix( 1, 1, mxUINT32_CLASS, mxREAL );

   
    nDeviceNo		= ( unsigned long )mxGetScalar( prhs[ 0 ] );
    nChildNo		= ( unsigned long )mxGetScalar( prhs[ 1 ] );
    n8BitSel		= ( unsigned long )mxGetScalar( prhs[ 2 ] );
    nBayer			= ( unsigned long )mxGetScalar( prhs[ 3 ] );
    nInterleave	    = ( unsigned long )mxGetScalar( prhs[ 4 ] );
 
    
    pRet			= ( unsigned long * )mxGetPr( plhs[ 0 ] );
    pErrorCode		= ( unsigned long * )mxGetPr( plhs[ 1 ] );

	
	*pRet			= PDC_SetTransferOption( nDeviceNo, nChildNo, n8BitSel, nBayer, nInterleave, pErrorCode );
}

