function varargout = RecordDuringSave2PortSample(varargin)
% RECORDDURINGSAVE2PORTSAMPLE MATLAB code for RecordDuringSave2PortSample.fig
%      RECORDDURINGSAVE2PORTSAMPLE, by itself, creates a new RECORDDURINGSAVE2PORTSAMPLE or raises the existing
%      singleton*.
%
%      H = RECORDDURINGSAVE2PORTSAMPLE returns the handle to a new RECORDDURINGSAVE2PORTSAMPLE or the handle to
%      the existing singleton*.
%
%      RECORDDURINGSAVE2PORTSAMPLE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RECORDDURINGSAVE2PORTSAMPLE.M with the given input arguments.
%
%      RECORDDURINGSAVE2PORTSAMPLE('Property','Value',...) creates a new RECORDDURINGSAVE2PORTSAMPLE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before RecordDuringSave2PortSample_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to RecordDuringSave2PortSample_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help RecordDuringSave2PortSample

% Last Modified by GUIDE v2.5 19-Nov-2013 17:11:59

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @RecordDuringSave2PortSample_OpeningFcn, ...
                   'gui_OutputFcn',  @RecordDuringSave2PortSample_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before RecordDuringSave2PortSample is made visible.
function RecordDuringSave2PortSample_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to RecordDuringSave2PortSample (see VARARGIN)
global g;

% Choose default command line output for RecordDuringSave2PortSample
handles.output = hObject;

%PDC_DEV_VALUE;
g = load('PDC_DEV_VALUE.mat');

try
    [ret errorCode] = PDC_Init;
    if ret == g.PDC_FAILED
        error('PDC_Init Error : %d', errorCode);
    end

    ipList = [uint32(hex2dec('C0A8000A'))]; % Camera IP Address 192.168.0.10

    [ret, detectNumInfo, errorCode] = PDC_DetectDevice(g.PDC_INTTYPE_G_ETHER, ipList, 1, 0);
    if ret == g.PDC_FAILED
        error('PDC_DetectDevice Error : %d', errorCode);
    end

    if detectNumInfo.m_nDeviceNum == 0
        error('DetectNumInfo.m_nDeviceNum Error : DetectNumInfo.m_nDeviceNum = 0');
    end

    [ret, deviceNo, errorCode ] = PDC_OpenDevice2(detectNumInfo.m_DetectInfo, 0, 1);
    if ret == g.PDC_FAILED
        error('PDC_OpenDevice Error : %d', errorCode);
    end
    
    [ret, ~, errorCode] = PDC_OpenSubInterface2(deviceNo, 0, 1);
    if ret == g.PDC_FAILED
        error('PDC_OpenSubInterface2 Error : %d', errorCode);
    end
    
	[ret, errorCode] = PDC_SetStatus(deviceNo, g.PDC_STATUS_LIVE);
    if ret == g.PDC_FAILED
        error('PDC_SetStatus Error : %d', errorCode);
    end
    
    [ret, errorCode] = PDC_SetPartitionIncMode(deviceNo, g.PDC_PARTITIONINC_MODE3);
    if ret == g.PDC_FAILED
        error('PDC_SetPartitionIncMode Error : %d', errorCode);
    end
    
    childNo = uint32(1);

    [ret, errorCode] = PDC_SetRecordRate(deviceNo, childNo, 60);
    if ret == g.PDC_FAILED
        error('PDC_SetRecordRate Error : %d', errorCode);
    end

    [ret, count, ~, errorCode] = PDC_GetMaxPartition(deviceNo, childNo);
    if ret == g.PDC_FAILED
        error('PDC_GetMaxPartition Error : %d', errorCode);
    end

    handles.maxPartition = count;
    handles.currentPartition = uint32(1);
    handles.memoryPartition = uint32(1);

    [ret, errorCode] = PDC_SetPartitionList(deviceNo, childNo, handles.maxPartition, 0);
    if ret == g.PDC_FAILED
        error('PDC_SetPartitionList Error : %d', errorCode);
    end

    [ret, errorCode] = PDC_SetCurrentPartition(deviceNo, childNo, handles.currentPartition);
    if ret == g.PDC_FAILED
        error('PDC_SetCurrentPartition Error : %d', errorCode);
    end

    [ret, errorCode] = PDC_SetMemoryModePartition(deviceNo, childNo, handles.memoryPartition);
    if ret == g.PDC_FAILED
        error('PDC_SetMemoryModePartition Error : %d', errorCode);
    end
    
    set(handles.numberOfPartition, 'String', num2str(handles.maxPartition));
    set(handles.recordPartitionNumber, 'String', num2str(handles.currentPartition));
    set(handles.savePartitionNumber, 'String', num2str(handles.memoryPartition));

    [ret, errorCode] = PDC_SetTriggerMode(deviceNo, g.PDC_TRIGGER_CENTER, 0, 0, 0);
    if ret == g.PDC_FAILED
        error('PDC_SetTriggerMode Error : %d', errorCode);
    end
    
    [ret, mode, errorCode] = PDC_GetColorType(deviceNo, childNo);
    if ret == g.PDC_FAILED
        error('PDC_GetColorType Error : %d', errorCode);
    end
    
    handles.colorType = mode;
    
    if mode == g.PDC_COLORTYPE_COLOR
        [ret, bitSel, ~, ~, errorCode] = PDC_GetTransferOption(deviceNo, childNo);
        if ret == g.PDC_FAILED
            error('PDC_GetTransferOption Error : %d', errorCode);
        end

        [ret, errorCode] = PDC_SetTransferOption(deviceNo, childNo, bitSel, g.PDC_FUNCTION_OFF, g.PDC_COLORDATA_INTERLEAVE_RGB); 
        if ret == g.PDC_FAILED
            error('PDC_SetTransferOption Error : %d', errorCode);
        end
    end
    
    [ret, width, height, errorCode] = PDC_GetResolution(deviceNo, childNo);
    if ret == g.PDC_FAILED
        error('PDC_GetResolution Error : %d', errorCode);
    end
    
    handles.imageWidth = width;
    handles.imageHeight = height;

    handles.deviceNo = deviceNo;
    handles.childNo = childNo;

    handles.liveTimer = timer('TimerFcn', {@LiveFcn, hObject}, 'Period', 0.001, 'ExecutionMode', 'fixedSpacing');

    handles.isRecording = false;
    handles.isSaving = false;
    handles.isTransfer1 = false;
    handles.isTransfer2 = false;
    handles.savingFrame = uint32(0);

    set(handles.savingFrameNumber, 'String', num2str(handles.savingFrame));
    
    handles.isCommand = false;
   
    % Update handles structure
    guidata(hObject, handles);
    
    start(handles.liveTimer);
    
    % UIWAIT makes RecordDuringSave2PortSample wait for user response (see UIRESUME)
    uiwait(handles.figure);
catch exception
    h = errordlg(exception.message, 'Record During Save Sample');
    uiwait(h);
    close;
end


% --- Callback function of the liveTimer.
function LiveFcn(~, ~, hFigure)
% hFigure    handle to figure

global g; % PDC_DEV_VALUE

handles = guidata(hFigure);

try
    if handles.isSaving
        startNo = handles.frameInfo.m_nStart;
        endNo = handles.frameInfo.m_nEnd;
        recordedFrames = handles.frameInfo.m_nRecordedFrames;

        data1 = [];
        data2 = [];
        
        if handles.isTransfer1
            [ret, data1, errorCode] = PDC_GetMemImageDataEnd2(handles.deviceNo, handles.childNo, 8, 1, handles.colorType, g.PDC_FUNCTION_OFF, handles.imageWidth, handles.imageHeight);
            if ret == g.PDC_FAILED
                error('PDC_GetMemImageDataEnd2 Error : %d', errorCode);
            end
           
            handles.savingFrame = handles.savingFrame + 1;
        end
        
        if handles.isTransfer2
           [ret, data2, errorCode] = PDC_GetMemImageDataEnd2(handles.deviceNo, handles.childNo, 8, 3, handles.colorType, g.PDC_FUNCTION_OFF, handles.imageWidth, handles.imageHeight);
           if ret == g.PDC_FAILED
                error('PDC_GetMemImageDataEnd2 Error : %d', errorCode);
           end
           
           handles.savingFrame = handles.savingFrame + 1;
        end
        
        set(handles.savingFrameNumber, 'String', num2str(handles.savingFrame));
        
        
        handles = CommandCheck(handles);
        handles = UpdateStatus(handles);
        
        if bitand(handles.savingFrame, 15) == 0
            LiveImageUpdate(handles);
        end

   
        if handles.savingFrame < recordedFrames
            frameNo = startNo + int32(handles.savingFrame);

            if frameNo < 0
                frameNo = endNo + abs(startNo) + frameNo + int32(1);
            end
            
            [ret, ~, errorCode] = PDC_GetMemImageDataStart2(handles.deviceNo, handles.childNo, frameNo, 8, 1, handles.colorType, g.PDC_FUNCTION_OFF, handles.imageWidth, handles.imageHeight);
            if ret == g.PDC_FAILED
                error('PDC_GetMemImageDataStart2 Error : %d', errorCode);
            end
            
            handles.isTransfer1 = true;
        else
            handles.isTransfer1 = false;
        end
        
        if (handles.savingFrame + 1) < recordedFrames
            frameNo = startNo + int32(handles.savingFrame + 1);
         
            if frameNo < 0
                frameNo = endNo + abs(startNo) + frameNo + int32(1);
            end
            
            [ret, ~, errorCode] = PDC_GetMemImageDataStart2(handles.deviceNo, handles.childNo, frameNo, 8, 3, handles.colorType, g.PDC_FUNCTION_OFF, handles.imageWidth, handles.imageHeight);
            if ret == g.PDC_FAILED
                error('PDC_GetMemImageDataStart2 Error : %d', errorCode);
            end
            
            handles.isTransfer2 = true;
        else
            handles.isTransfer2 = false;
        end
        
        
        if ~isempty(data1)
           try
               if handles.colorType == g.PDC_COLORTYPE_MONO
                   handles.aviObj = addframe(handles.aviObj, data1.');
               else
                   handles.aviObj = addframe(handles.aviObj, permute(data1,[3 2 1]));
               end
           catch exception
               h = errordlg(exception.message, 'Record During Save Sample');
               uiwait(h);
        
               handles.isTransfer1 = false; % for file close
           end
        end
      
        if ~isempty(data2)
           try
               if handles.colorType == g.PDC_COLORTYPE_MONO
                   handles.aviObj = addframe(handles.aviObj, data2.');
               else
                   handles.aviObj = addframe(handles.aviObj, permute(data2,[3 2 1]));
               end
           catch exception
               h = errordlg(exception.message, 'Record During Save Sample');
               uiwait(h);
        
               handles.isTransfer1 = false; % for file close
           end
        end
        

        if handles.isTransfer1 == false;
            handles.isSaving = false;

            try
                handles.aviObj = close(handles.aviObj);
            catch exception
                h = errordlg(exception.message, 'Record During Save Sample');
                uiwait(h);
            end
            
            if handles.memoryPartition ~= handles.maxPartition
                handles.memoryPartition = handles.memoryPartition + 1;
            else
                handles.memoryPartition = uint32(1);
            end
            
            [ret, errorCode] = PDC_SetMemoryModePartition(handles.deviceNo, handles.childNo, handles.memoryPartition);
            if ret == g.PDC_FAILED
                error('PDC_SetMemoryModePartition Error : %d', errorCode);
            end
            
            set(handles.savePartitionNumber, 'String', num2str(handles.memoryPartition));
        end
    else
        handles = CommandCheck(handles);
        handles = UpdateStatus(handles);
        
        if handles.currentPartition ~= handles.memoryPartition
            handles.isSaving = true;
            handles.savingFrame = uint32(0);
            
            [ret, frameInfo, errorCode] = PDC_GetMemFrameInfo(handles.deviceNo, handles.childNo);
            if ret == g.PDC_FAILED
                error('PDC_GetMemFrameInfo Error : %d', errorCode);
            end

            handles.frameInfo = frameInfo;

            pathName = get(handles.savePathName, 'String');
            fileName = sprintf('%s_%d.avi', get(handles.saveFileName, 'String'), handles.memoryPartition);
            
            fileName = fullfile(pathName, fileName);
            
            try 
                if handles.colorType == g.PDC_COLORTYPE_MONO
                    handles.aviObj = avifile(fileName, 'compression', 'None', 'colormap', colormap(gray(256)), 'fps', 30);
                else
                    handles.aviObj = avifile(fileName, 'compression', 'None', 'fps', 30);
                end
            catch exception
               h = errordlg(exception.message, 'Record During Save Sample');
               uiwait(h);
               
               handles.isSaving = false;
            
               if handles.memoryPartition ~= handles.maxPartition
                   handles.memoryPartition = handles.memoryPartition + 1; % skip partition
               else
                   handles.memoryPartition = uint32(1);
               end
               
               [ret, errorCode] = PDC_SetMemoryModePartition(handles.deviceNo, handles.childNo, handles.memoryPartition);
               if ret == g.PDC_FAILED
                   error('PDC_SetMemoryModePartition Error : %d', errorCode);
               end
            
               set(handles.savePartitionNumber, 'String', num2str(handles.memoryPartition));
            end
        end

        LiveImageUpdate(handles);
    end
catch exception
    h = errordlg(exception.message, 'Record During Save Sample');
    uiwait(h);
end

guidata(handles.output, handles);

drawnow;


% --- Update a live image of axes.
function LiveImageUpdate(handles)
% handles    structure with handles and user data (see GUIDATA)

global g; % PDC_DEV_VALUE

try
    if handles.colorType == g.PDC_COLORTYPE_MONO
        [ret, data, errorCode] = PDC_GetLiveImageData(handles.deviceNo, handles.childNo, 8, g.PDC_COLORTYPE_MONO, g.PDC_FUNCTION_OFF, handles.imageWidth, handles.imageHeight);
        if ret == g.PDC_FAILED
            error('PDC_GetLiveImageData Error : %d', errorCode);
        end

        colormap(handles.frame, gray(256));
        image(data.', 'Parent', handles.frame);
    else
        [ret, data, errorCode] = PDC_GetLiveImageData(handles.deviceNo, handles.childNo, 8, g.PDC_COLORTYPE_COLOR, g.PDC_FUNCTION_OFF, handles.imageWidth, handles.imageHeight);
        if ret == g.PDC_FAILED
            error('PDC_GetLiveImageData Error : %d', errorCode);
        end

        data = permute(data,[3 2 1]);
        
        image(data, 'Parent', handles.frame);
    end
    
    set(handles.frame, 'Visible', 'off');
catch exception
    h = errordlg(exception.message, 'Record During Save Sample');
    uiwait(h);
end

% --- Update a status.
function varargout = UpdateStatus(handles)
% handles    structure with handles and user data (see GUIDATA)

global g; % PDC_DEV_VALUE

try 
    [ret, status, errorCode] = PDC_GetStatus(handles.deviceNo, handles.childNo);
    if ret == g.PDC_FAILED
        error('PDC_GetStatus Error : %d', errorCode);
    end

    switch status
        case {g.PDC_STATUS_LIVE}
            set(handles.status, 'String', 'Live');
            set(handles.command, 'String', 'RecReady');
            if handles.isRecording == true
                handles.isRecording = false;

                if handles.currentPartition ~= handles.maxPartition
                    handles.currentPartition = handles.currentPartition + 1;
                else
                    handles.currentPartition = uint32(1);
                end
            
                [ret, errorCode] = PDC_SetCurrentPartition(handles.deviceNo, handles.childNo, handles.currentPartition);
                if ret == g.PDC_FAILED
                    error('PDC_SetCurrentPartition Error : %d', errorCode);
                end
                
                set(handles.recordPartitionNumber, 'String', num2str(handles.currentPartition));
            end
        case {g.PDC_STATUS_RECREADY}
            set(handles.status, 'String', 'RecReady');
            set(handles.command, 'String', 'Trigger In');
        case {g.PDC_STATUS_ENDLESS}
            set(handles.status, 'String', 'Endless');
            set(handles.command, 'String', 'Trigger In');
        case {g.PDC_STATUS_REC}
            set(handles.status, 'String', 'Record');
            set(handles.command, 'String', 'Cancel');
    end
catch exception
    h = errordlg(exception.message, 'Record During Save Sample');
    uiwait(h);
end

varargout{1} = handles;


% --- Update a status.
function varargout = CommandCheck(handles)
% handles    structure with handles and user data (see GUIDATA)
global g; % PDC_DEV_VALUE


if handles.isCommand
    handles.isCommand = false;
    
    try
        [ret, status, errorCode] = PDC_GetStatus(handles.deviceNo, handles.childNo);
        if ret == g.PDC_FAILED
            error('PDC_GetStatus Error : %d', errorCode);
        end

        switch status
            case {g.PDC_STATUS_LIVE}
                [ret, errorCode] = PDC_SetRecReady(handles.deviceNo, handles.childNo);
                if ret == g.PDC_FAILED
                    error('PDC_SetRecReady Error : %d', errorCode);
                end
            case {g.PDC_STATUS_RECREADY}
                [ret, errorCode] = PDC_TriggerIn(handles.deviceNo, handles.childNo);
                if ret == g.PDC_FAILED
                    error('PDC_TriggerIn Error : %d', errorCode);
                end
                handles.isRecording = true;
            case {g.PDC_STATUS_ENDLESS}
                [ret, errorCode] = PDC_TriggerIn(handles.deviceNo, handles.childNo);
                if ret == g.PDC_FAILED
                    error('PDC_TriggerIn Error : %d', errorCode);
                end
                handles.isRecording = true;
            case {g.PDC_STATUS_REC}
                [ret, errorCode] = PDC_SetStatus(handles.deviceNo, g.PDC_STATUS_LIVE);
                if ret == g.PDC_FAILED
                    error('PDC_SetStatus Error : %d', errorCode);
                end
                handles.isRecording = false;
        end
    catch exception
        h = errordlg(exception.message, 'Record During Save Sample');
        uiwait(h);
    end
end

varargout{1} = handles;


% --- Outputs from this function are returned to the command line.
function varargout = RecordDuringSave2PortSample_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
% varargout{1} = handles.output;


% --- Executes when user attempts to close figure.
function figure_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isfield(handles, 'liveTimer')
    stop(handles.liveTimer);
    delete(handles.liveTimer);
end

% Hint: delete(hObject) closes the figure
delete(hObject);

clear mex;


function savePathName_Callback(hObject, eventdata, handles)
% hObject    handle to savePathName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of savePathName as text
%        str2double(get(hObject,'String')) returns contents of savePathName as a double


% --- Executes during object creation, after setting all properties.
function savePathName_CreateFcn(hObject, eventdata, handles)
% hObject    handle to savePathName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function saveFileName_Callback(hObject, eventdata, handles)
% hObject    handle to saveFileName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of saveFileName as text
%        str2double(get(hObject,'String')) returns contents of saveFileName as a double


% --- Executes during object creation, after setting all properties.
function saveFileName_CreateFcn(hObject, eventdata, handles)
% hObject    handle to saveFileName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in selectPath.
function selectPath_Callback(hObject, eventdata, handles)
% hObject    handle to selectPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
defFolder = get(handles.savePathName, 'String');
folder_name = uigetdir(defFolder);

if ischar(folder_name)
    set(handles.savePathName, 'String', folder_name);
end


% --- Executes on button press in command.
function command_Callback(hObject, eventdata, handles)
% hObject    handle to command (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.isCommand = true;

guidata(handles.output, handles);


function numberOfPartition_Callback(hObject, eventdata, handles)
% hObject    handle to numberOfPartition (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numberOfPartition as text
%        str2double(get(hObject,'String')) returns contents of numberOfPartition as a double


% --- Executes during object creation, after setting all properties.
function numberOfPartition_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numberOfPartition (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function recordPartitionNumber_Callback(hObject, eventdata, handles)
% hObject    handle to recordPartitionNumber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of recordPartitionNumber as text
%        str2double(get(hObject,'String')) returns contents of recordPartitionNumber as a double


% --- Executes during object creation, after setting all properties.
function recordPartitionNumber_CreateFcn(hObject, eventdata, handles)
% hObject    handle to recordPartitionNumber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function savePartitionNumber_Callback(hObject, eventdata, handles)
% hObject    handle to savePartitionNumber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of savePartitionNumber as text
%        str2double(get(hObject,'String')) returns contents of savePartitionNumber as a double


% --- Executes during object creation, after setting all properties.
function savePartitionNumber_CreateFcn(hObject, eventdata, handles)
% hObject    handle to savePartitionNumber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function savingFrameNumber_Callback(hObject, eventdata, handles)
% hObject    handle to savingFrameNumber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of savingFrameNumber as text
%        str2double(get(hObject,'String')) returns contents of savingFrameNumber as a double


% --- Executes during object creation, after setting all properties.
function savingFrameNumber_CreateFcn(hObject, eventdata, handles)
% hObject    handle to savingFrameNumber (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
